<template>
  <div class="carousel-container">
    <div
      class="carousel-background"
      :style="backgroundStyle"
    />
    <component :is="currentComponent" />
    <ul class="paginator">
      <li
        class="page is-unselectable"
        v-for="(slide, index) in slides"
        :key="index"
        @click="onChangeSlide(index)"
      >
        <i class="material-icons">
          {{ isChecked(slide) }}
        </i>
      </li>
    </ul>
  </div>
</template>

<script>
import FirstSlide from './Slides/FirstSlide.vue'
import SecondSlide from './Slides/SecondSlide.vue'
import ThirdSlide from './Slides/ThirdSlide.vue'

export default {
  name: 'TheCarousel',
  components: {
    FirstSlide,
    SecondSlide,
    ThirdSlide
  },
  data () {
    return {
      interval: null,
      currentSlide: 'first',
      slides: [
        { value: 'bg_model_1.jpg', name: 'first', component: 'FirstSlide' },
        { value: 'bg_model_2.jpg', name: 'second', component: 'SecondSlide' },
        { value: 'bg_model_3.jpg', name: 'third', component: 'ThirdSlide' }
      ]
    }
  },
  computed: {
    currentSlideValue () {
      const [ firstSlide = {} ] = this.slides
      const slide = this.slides.find(slide => slide.name === this.currentSlide)
      if (slide) return slide.value
      return firstSlide.value
    },
    backgroundStyle () {
      return {
        backgroundImage: `url(/images/${this.currentSlideValue})`
      }
    },
    currentComponent () {
      const [ firstSlide = {} ] = this.slides
      const slide = this.slides.find(slide => slide.name === this.currentSlide)
      if (slide) return slide.component
      return firstSlide.component
    },
    isChecked () {
      return (slide) => slide.name === this.currentSlide ? 'radio_button_checked' : 'radio_button_unchecked'
    }
  },
  beforeMount () {
    // this.interval = setInterval(this.nextSlide, 120000)
    this.interval = setInterval(this.nextSlide, 60000)
  },
  beforeDestroy() {
    clearInterval(this.interval)
  },
  methods: {
    nextSlide () {
      const [ firstSlide ] = this.slides
      const currentIndex = this.slides.findIndex(slide => slide.name === this.currentSlide)
      const nextIndex = currentIndex + 1
      if (nextIndex === this.slides.length) this.currentSlide = firstSlide.name
      else this.currentSlide = this.slides[nextIndex].name
    },
    onChangeSlide (index) {
      this.currentSlide = this.slides[index].name
      clearInterval(this.interval)
      this.interval = setInterval(this.nextSlide, 60000)
    }
  }
}
</script>

<style>
  .carousel-container {
    height: calc(100vh - 52px);
    width: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    overflow-y: auto;
    position: relative;
    flex-direction: column;
  }

  .carousel-container .carousel-background {
    height: 100%;
    width: 100%;
    background-position: 42.5%;
    background-repeat: no-repeat;
    background-size: cover;
    position: absolute;
  }

  .carousel-container .box {
    max-width: 90%;
    z-index: 2;
    background: rgba(255, 255, 255, .6);
  }

  .carousel-container .box .title {
    font-size: 4rem;
    text-transform: uppercase;
    letter-spacing: 0.04em;
    position: relative;
    word-wrap: break-word;
    overflow-wrap: break-word;
    hyphens: none;
    line-height: 1.2;
    font-style: normal;
    font-weight: 400;
    line-height: 1.333;
    font-family: Dosis, sans-serif;
    color: #212121;
    margin-bottom: 2rem;
    padding-bottom: 1rem;
    border-bottom: solid 4px #ddb0b7;
  }

  .carousel-container .box p {
    font-style: normal;
    font-weight: 400;
    font-size: 1rem;
    line-height: 1.7;
    font-family: Dosis, sans-serif;
    letter-spacing: 0.02em;
    text-align: inherit;
    color: #212121;
  }

  .carousel-container .box .button {
    margin-top: 2rem;
    border-color: #ddb0b7;
    background-color: #ddb0b7;
    padding: 1.5rem 2rem;
  }

  .carousel-container .paginator {
    bottom: .5rem;
    z-index: 2;
    display: flex;
    color: #cb97a0;
    position: absolute;
  }

  .carousel-container .paginator li {
    cursor: pointer;
  }

  .carousel-container .paginator .page {
    padding: .25rem
  }

  @media screen and (min-width: 769px) {
    .carousel-container {
      align-items: flex-end;
    }

    .carousel-container .box {
      max-width: 50%;
      background: none;
      border: none;
      box-shadow: none;
      margin-right: 2rem;
    }

    .carousel-container .paginator {
      left: 50%;
      bottom: 10%;
    }
  }
</style>
